# BSN开发的合约说明

## 1. 产品合约

负责维护产品的所有者，外围组件生成产品唯一ID后填入想关信息

- owner的变化(出库入库)，在产品生产和所有权变动时进行改动
- 产品的属性：生产日期，批号，废弃状态，所用组件的来源(生产)...
- 查看产品属性值(不能编辑)，只能编辑产品的owner

## 2 结算合约

负责用户资产

- 余额与预付款队列
- 产品所有权变化(手动确认)过程中的自动结算
- 资金如果不足，不能进行诸如备货，入库等的操作。
- 充值/直接消费/预付款, 余额查询等相关功能

## 3. 库存合约

拥有**生产个数**和**已拥有产品队列**。入库出库对这两个队列进行操作, 同时进行结算。

- 生产厂家进行下产品订单(手动)，调用结算合约的预付款，向厂家预付(自动)
- 厂家向仓库交货，仓库手动确认后(预付款划拨到厂家余额)，更改产品合约中的产品所有权

## 4. 生产合约

拥有**库存生产个数**和**已拥产品队列**, 和**原材料批次**队列。

- 获取待生产订单，判断原料库存是否满足需求，不满足则通过结算合约向备货合约预付款下生产订单
- 通过计算原材料队列，外部唯一标识生成，将原材料的批次信息写入产品进行生产(外部)，入库(调用产品合约的生成入口)。对**库存生产个数**和**已拥有产品队列**进行维护
- 出库(外部调用产品合约的产品所有权变更入口)，对本合约的**生产个数**和**已拥有产品队列**进行维护，及库存合约的**已拥有产品队列**进行维护，通过通过结算合约进行结算。

## 5. 备货合约

负责对上游厂商进行备货

- 通过调用**生产备货数**对厂家B进行备货，计算已有零件数，外部调用零件入库(填入批次，数量等信息)
- 出库(外部调用)，将零件信息的批次信息写入到厂家B, 并维护自身数据队列，完成后自动调用结算合约进行结算

补充： 因为零件不像产品一物一码，多个零件只许对应到某个批次就可以，不需要单独的零件合约对零件进行维护

## 6. 授权合约

通过不同的权限等级，对各个合约中的函数进行访问限制。



## 附： 删除数组元素合约

```sol
contract test{
    uint[] array = [1,2,3,4,5];
    function remove(uint index)  returns(uint[]) {
        if (index >= array.length) return;

        for (uint i = index; i<array.length-1; i++){
            array[i] = array[i+1];
        }
        delete array[array.length-1];
        array.length--;
        return array;
    }
}
```



